package com.glxp.api.admin.dao.basic;

import com.glxp.api.admin.entity.basic.CompanyProductRelevanceEntity;
import com.glxp.api.admin.req.basic.CompanyProductRelevanceRequest;
import com.glxp.api.admin.req.basic.FilterCompanyProductRelevanceRequest;
import com.glxp.api.admin.res.info.CompanyProductRelevanceResponse;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface CompanyProductRelevanceDao {

    List<CompanyProductRelevanceResponse> filterUdiGp(CompanyProductRelevanceRequest basicInstrumentMaintainRequest);

    List<CompanyProductRelevanceEntity> filterCompanyProductRelevance(FilterCompanyProductRelevanceRequest filterCompanyProductRelevanceRequest);

    CompanyProductRelevanceEntity findCompanyProductRelevance(Long CustomerId);


    CompanyProductRelevanceEntity findCompanyProductRelevanceByProductId(String productId);

    CompanyProductRelevanceEntity findCompanyProductRelevanceByUdiRlIdFk(@Param("udiRlIdFk") String udiRlIdFk, @Param("customerId") String customerId);

    CompanyProductRelevanceEntity findCompanyProductRelevanceByProductUuid(CompanyProductRelevanceEntity companyProductRelevanceEntity);

    List<CompanyProductRelevanceEntity> getCompanyProductRelevance(FilterCompanyProductRelevanceRequest filterCompanyProductRelevanceRequest);

    boolean updateCompanyProductRelevance(CompanyProductRelevanceEntity companyCertEntity);

    boolean insertCompanyProductRelevance(CompanyProductRelevanceEntity companyCertEntity);

    boolean deleteById(String id);

    boolean deleteByRlId(String id);
}
