package com.glxp.api.admin.dao.business;

import com.glxp.api.admin.entity.business.StockOrderEntity;
import com.glxp.api.admin.entity.business.StockOrderPrintEntity;
import com.glxp.api.admin.req.business.StockOrderFilterRequest;
import com.glxp.api.admin.req.business.StockOrderQueryRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface StockOrderDao {

    List<StockOrderEntity> listStockOrder(StockOrderQueryRequest stockOrderQueryRequest);

    List<StockOrderEntity> listStockOrderNoDealWith(StockOrderQueryRequest stockOrderQueryRequest);

    boolean insertStockOrder(StockOrderEntity stockOrderEntity);

    boolean updateById(StockOrderEntity stockOrderEntity);

    boolean deleteByOrderId(@Param("orderId") String orderId);

    boolean deleteById(@Param("id") String id);

    boolean updateByStatus(@Param("orderId") String orderId, @Param("status") Integer status);

    List<StockOrderEntity> filterListOr(StockOrderFilterRequest stockOrderFilterRequest);

    StockOrderEntity findOne(StockOrderFilterRequest stockOrderFilterRequest);
    
    List<StockOrderPrintEntity> listOrderPrint(StockOrderFilterRequest stockOrderFilterRequest);
}
