package com.glxp.api.admin.thread;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.glxp.api.admin.constant.ConstantStatus;
import com.glxp.api.admin.entity.info.SystemParamConfigEntity;
import com.glxp.api.admin.entity.inout.IOOrderStatusEntity;
import com.glxp.api.admin.entity.inout.OrderEntity;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.req.inout.PostOrderRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.res.inout.DlOrderResponse;
import com.glxp.api.admin.service.info.SystemParamConfigService;
import com.glxp.api.admin.service.inout.CodesService;
import com.glxp.api.admin.service.inout.IOOrderStatusService;
import com.glxp.api.admin.service.inout.OrderService;
import com.glxp.api.admin.util.CustomUtil;
import com.glxp.api.admin.util.FileUtils;
import com.glxp.api.admin.util.SpGetHttp;
import com.glxp.api.common.res.BaseResponse;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
public class DlSpOrderService {
    @Resource
    SpGetHttp spGetHttp;
    @Resource
    SystemParamConfigService systemParamConfigService;
    @Resource
    IOOrderStatusService ioOrderStatusService;
    @Resource
    IoTransInoutService transInoutService;

    @Async
    public void dlOrdedrs() {
        BaseResponse<PageSimpleResponse<IOOrderStatusEntity>> baseResponse = spGetHttp.getOrderStatus();
        PageSimpleResponse<IOOrderStatusEntity> pageSimpleResponse = baseResponse.getData();
        if (pageSimpleResponse != null) {
            List<IOOrderStatusEntity> ioOrderStatusEntityList = pageSimpleResponse.getList();
            if (ioOrderStatusEntityList != null && ioOrderStatusEntityList.size() > 0) {
                for (IOOrderStatusEntity ioOrderStatusEntity : ioOrderStatusEntityList) {
                    BaseResponse<List<DlOrderResponse>> ordersRes = spGetHttp.getOrders(ioOrderStatusEntity.getOrderId());
                    List<DlOrderResponse> dlOrderResponses = ordersRes.getData();
                    if (dlOrderResponses != null && dlOrderResponses.size() > 0) {
                        for (DlOrderResponse dlOrderResponse : dlOrderResponses) {
                            OrderEntity orderEntity = dlOrderResponse.getOrderEntity();
                            IOOrderStatusEntity temp = ioOrderStatusService.findByOrderId(orderEntity.getId());
                            if (temp == null) {//避免重复操作插入
                                List<PostOrderRequest.PostOrder> postOrders = new ArrayList<>();
                                PostOrderRequest postOrderRequest = new PostOrderRequest();
                                List<WarehouseEntity> warehouseEntityList = dlOrderResponse.getCodes();
                                PostOrderRequest.PostOrder postOrder = new PostOrderRequest.PostOrder();
                                postOrder.setCodes(warehouseEntityList);
                                postOrder.setBillType(orderEntity.getAction());
                                postOrders.add(postOrder);
                                postOrderRequest.setPostOrders(postOrders);
                                transInoutService.creatOrderAsycn(postOrderRequest, ConstantStatus.FROM_UDISP);
                            }
                            spGetHttp.postOrder(orderEntity.getId());
                        }

                    }
                }

            }
        }
    }

}
